import { parse as Q, toDate as G, format as m, setDay as N, setMonth as $ } from "date-fns";
import { createElementBlock as f, openBlock as h, normalizeClass as c, createCommentVNode as E, renderSlot as g, createElementVNode as y, createTextVNode as v, toDisplayString as D, withKeys as u, withModifiers as d, Fragment as j, renderList as q, resolveComponent as C, withDirectives as B, normalizeStyle as U, createVNode as F, withCtx as b, vShow as Y, createBlock as Z, resolveDynamicComponent as _ } from "vue";
/*!
 * vuejs-datepicker v4.2.1
 * (c) 2023-2025 Wesley Hobbie
 * Released under the MIT License.
 */
function V(e) {
  return (t = {}) => {
    const s = t.width ? String(t.width) : e.defaultWidth;
    return e.formats[s] || e.formats[e.defaultWidth];
  };
}
function k(e) {
  return (t, s) => {
    const i = s != null && s.context ? String(s.context) : "standalone";
    let r;
    if (i === "formatting" && e.formattingValues) {
      const n = e.defaultFormattingWidth || e.defaultWidth, o = s != null && s.width ? String(s.width) : n;
      r = e.formattingValues[o] || e.formattingValues[n];
    } else {
      const n = e.defaultWidth, o = s != null && s.width ? String(s.width) : e.defaultWidth;
      r = e.values[o] || e.values[n];
    }
    const a = e.argumentCallback ? e.argumentCallback(t) : t;
    return r[a];
  };
}
function T(e) {
  return (t, s = {}) => {
    const i = s.width, r = i && e.matchPatterns[i] || e.matchPatterns[e.defaultMatchWidth], a = t.match(r);
    if (!a)
      return null;
    const n = a[0], o = i && e.parsePatterns[i] || e.parsePatterns[e.defaultParseWidth], l = Array.isArray(o) ? te(o, (O) => O.test(n)) : (
      // [TODO] -- I challenge you to fix the type
      ee(o, (O) => O.test(n))
    );
    let P;
    P = e.valueCallback ? e.valueCallback(l) : l, P = s.valueCallback ? (
      // [TODO] -- I challenge you to fix the type
      s.valueCallback(P)
    ) : P;
    const X = t.slice(n.length);
    return { value: P, rest: X };
  };
}
function ee(e, t) {
  for (const s in e)
    if (Object.prototype.hasOwnProperty.call(e, s) && t(e[s]))
      return s;
}
function te(e, t) {
  for (let s = 0; s < e.length; s++)
    if (t(e[s]))
      return s;
}
function se(e) {
  return (t, s = {}) => {
    const i = t.match(e.matchPattern);
    if (!i) return null;
    const r = i[0], a = t.match(e.parsePattern);
    if (!a) return null;
    let n = e.valueCallback ? e.valueCallback(a[0]) : a[0];
    n = s.valueCallback ? s.valueCallback(n) : n;
    const o = t.slice(r.length);
    return { value: n, rest: o };
  };
}
const ie = {
  lessThanXSeconds: {
    one: "less than a second",
    other: "less than {{count}} seconds"
  },
  xSeconds: {
    one: "1 second",
    other: "{{count}} seconds"
  },
  halfAMinute: "half a minute",
  lessThanXMinutes: {
    one: "less than a minute",
    other: "less than {{count}} minutes"
  },
  xMinutes: {
    one: "1 minute",
    other: "{{count}} minutes"
  },
  aboutXHours: {
    one: "about 1 hour",
    other: "about {{count}} hours"
  },
  xHours: {
    one: "1 hour",
    other: "{{count}} hours"
  },
  xDays: {
    one: "1 day",
    other: "{{count}} days"
  },
  aboutXWeeks: {
    one: "about 1 week",
    other: "about {{count}} weeks"
  },
  xWeeks: {
    one: "1 week",
    other: "{{count}} weeks"
  },
  aboutXMonths: {
    one: "about 1 month",
    other: "about {{count}} months"
  },
  xMonths: {
    one: "1 month",
    other: "{{count}} months"
  },
  aboutXYears: {
    one: "about 1 year",
    other: "about {{count}} years"
  },
  xYears: {
    one: "1 year",
    other: "{{count}} years"
  },
  overXYears: {
    one: "over 1 year",
    other: "over {{count}} years"
  },
  almostXYears: {
    one: "almost 1 year",
    other: "almost {{count}} years"
  }
}, ae = (e, t, s) => {
  let i;
  const r = ie[e];
  return typeof r == "string" ? i = r : t === 1 ? i = r.one : i = r.other.replace("{{count}}", t.toString()), s != null && s.addSuffix ? s.comparison && s.comparison > 0 ? "in " + i : i + " ago" : i;
}, ne = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: "P"
}, re = (e, t, s, i) => ne[e], le = {
  narrow: ["B", "A"],
  abbreviated: ["BC", "AD"],
  wide: ["Before Christ", "Anno Domini"]
}, oe = {
  narrow: ["1", "2", "3", "4"],
  abbreviated: ["Q1", "Q2", "Q3", "Q4"],
  wide: ["1st quarter", "2nd quarter", "3rd quarter", "4th quarter"]
}, ue = {
  narrow: ["J", "F", "M", "A", "M", "J", "J", "A", "S", "O", "N", "D"],
  abbreviated: [
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
  ],
  wide: [
    "January",
    "February",
    "March",
    "April",
    "May",
    "June",
    "July",
    "August",
    "September",
    "October",
    "November",
    "December"
  ]
}, de = {
  narrow: ["S", "M", "T", "W", "T", "F", "S"],
  short: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
  abbreviated: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  wide: [
    "Sunday",
    "Monday",
    "Tuesday",
    "Wednesday",
    "Thursday",
    "Friday",
    "Saturday"
  ]
}, he = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  }
}, ce = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  }
}, fe = (e, t) => {
  const s = Number(e), i = s % 100;
  if (i > 20 || i < 10)
    switch (i % 10) {
      case 1:
        return s + "st";
      case 2:
        return s + "nd";
      case 3:
        return s + "rd";
    }
  return s + "th";
}, ge = {
  ordinalNumber: fe,
  era: k({
    values: le,
    defaultWidth: "wide"
  }),
  quarter: k({
    values: oe,
    defaultWidth: "wide",
    argumentCallback: (e) => e - 1
  }),
  month: k({
    values: ue,
    defaultWidth: "wide"
  }),
  day: k({
    values: de,
    defaultWidth: "wide"
  }),
  dayPeriod: k({
    values: he,
    defaultWidth: "wide",
    formattingValues: ce,
    defaultFormattingWidth: "wide"
  })
}, be = /^(\d+)(th|st|nd|rd)?/i, me = /\d+/i, pe = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
}, ye = {
  any: [/^b/i, /^(a|c)/i]
}, De = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
}, we = {
  any: [/1/i, /2/i, /3/i, /4/i]
}, ve = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
}, Ce = {
  narrow: [
    /^j/i,
    /^f/i,
    /^m/i,
    /^a/i,
    /^m/i,
    /^j/i,
    /^j/i,
    /^a/i,
    /^s/i,
    /^o/i,
    /^n/i,
    /^d/i
  ],
  any: [
    /^ja/i,
    /^f/i,
    /^mar/i,
    /^ap/i,
    /^may/i,
    /^jun/i,
    /^jul/i,
    /^au/i,
    /^s/i,
    /^o/i,
    /^n/i,
    /^d/i
  ]
}, Fe = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
}, Me = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
}, Pe = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
}, ke = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
}, Te = {
  ordinalNumber: se({
    matchPattern: be,
    parsePattern: me,
    valueCallback: (e) => parseInt(e, 10)
  }),
  era: T({
    matchPatterns: pe,
    defaultMatchWidth: "wide",
    parsePatterns: ye,
    defaultParseWidth: "any"
  }),
  quarter: T({
    matchPatterns: De,
    defaultMatchWidth: "wide",
    parsePatterns: we,
    defaultParseWidth: "any",
    valueCallback: (e) => e + 1
  }),
  month: T({
    matchPatterns: ve,
    defaultMatchWidth: "wide",
    parsePatterns: Ce,
    defaultParseWidth: "any"
  }),
  day: T({
    matchPatterns: Fe,
    defaultMatchWidth: "wide",
    parsePatterns: Me,
    defaultParseWidth: "any"
  }),
  dayPeriod: T({
    matchPatterns: Pe,
    defaultMatchWidth: "any",
    parsePatterns: ke,
    defaultParseWidth: "any"
  })
}, Se = {
  full: "EEEE, MMMM do, y",
  long: "MMMM do, y",
  medium: "MMM d, y",
  short: "MM/dd/yyyy"
}, Ee = {
  full: "h:mm:ss a zzzz",
  long: "h:mm:ss a z",
  medium: "h:mm:ss a",
  short: "h:mm a"
}, Ie = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: "{{date}}, {{time}}",
  short: "{{date}}, {{time}}"
}, Oe = {
  date: V({
    formats: Se,
    defaultWidth: "full"
  }),
  time: V({
    formats: Ee,
    defaultWidth: "full"
  }),
  dateTime: V({
    formats: Ie,
    defaultWidth: "full"
  })
}, S = {
  code: "en-US",
  formatDistance: ae,
  formatLong: Oe,
  formatRelative: re,
  localize: ge,
  match: Te,
  options: {
    weekStartsOn: 0,
    firstWeekContainsDate: 1
  }
}, K = {
  /**
   * @type {Boolean}
   */
  useUtc: !1,
  /**
   * @type {Locale}
   */
  language: S,
  /**
   * Returns the full year, using UTC or not
   * @param {Date} date
   */
  getFullYear(e) {
    return this.useUtc ? e.getUTCFullYear() : e.getFullYear();
  },
  /**
   * Returns the month, using UTC or not
   * @param {Date} date
   */
  getMonth(e) {
    return this.useUtc ? e.getUTCMonth() : e.getMonth();
  },
  /**
   * Returns the number of days in the month, using UTC or not
   * @param {Date} date
   */
  getDaysInMonth(e) {
    return this.daysInMonth(this.getFullYear(e), this.getMonth(e));
  },
  /**
   * Returns the date, using UTC or not
   * @param {Date} date
   */
  getDate(e) {
    return this.useUtc ? e.getUTCDate() : e.getDate();
  },
  /**
   * Returns the day, using UTC or not
   * @param {Date} date
   */
  getDay(e) {
    return this.useUtc ? e.getUTCDay() : e.getDay();
  },
  /**
   * Returns the hours, using UTC or not
   * @param {Date} date
   */
  getHours(e) {
    return this.useUtc ? e.getUTCHours() : e.getHours();
  },
  /**
   * Returns the minutes, using UTC or not
   * @param {Date} date
   */
  getMinutes(e) {
    return this.useUtc ? e.getUTCMinutes() : e.getMinutes();
  },
  /**
   * Sets the full year, using UTC or not
   * @param {Date} date
   * @param {String, Number} value
   */
  setFullYear(e, t) {
    return this.useUtc ? e.setUTCFullYear(t) : e.setFullYear(t);
  },
  /**
   * Sets the month, using UTC or not
   * @param {Date} date
   * @param {String, Number} value
   */
  setMonth(e, t) {
    return this.useUtc ? e.setUTCMonth(t) : e.setMonth(t);
  },
  /**
   * Sets the date, using UTC or not
   * @param {Date} date
   * @param {String, Number} value
   */
  setDate(e, t) {
    return this.useUtc ? e.setUTCDate(t) : e.setDate(t);
  },
  /**
   * Check if date1 is equivalent to date2, without comparing the time
   * @see https://stackoverflow.com/a/6202196/4455925
   * @param {Date} date1
   * @param {Date} date2
   */
  compareDates(e, t) {
    const s = new Date(e.getTime()), i = new Date(t.getTime());
    return this.useUtc ? (s.setUTCHours(0, 0, 0, 0), i.setUTCHours(0, 0, 0, 0)) : (s.setHours(0, 0, 0, 0), i.setHours(0, 0, 0, 0)), s.getTime() === i.getTime();
  },
  /**
   * Validates a date object
   * @param {Date} date - an object instantiated with the new Date constructor
   * @return {Boolean}
   */
  isValidDate(e) {
    return Object.prototype.toString.call(e) !== "[object Date]" ? !1 : !isNaN(e.getTime());
  },
  /**
   * Return abbreviated week day name
   * @param {Date} date
   * @return {String}
   */
  getDayNameAbbr(e) {
    if (typeof e != "object")
      throw TypeError("Invalid Type");
    return m(e, "ccc", { locale: this.language });
  },
  /**
   * Return day number from abbreviated week day name
   * @param {String} abbr
   * @return {Number}
   */
  getDayFromAbbr(e) {
    const t = /* @__PURE__ */ new Date(), s = [0, 1, 2, 3, 4, 5, 6];
    let i = s.map((r) => m(
      N(t, r),
      "ccc",
      { locale: S }
    ));
    for (let r = 0; r < i.length; r++)
      if (e.toLowerCase() === i[r].toLowerCase())
        return r;
    if (this.language !== S) {
      i = s.map((r) => m(
        N(t, r),
        "ccc",
        { locale: this.language }
      ));
      for (let r = 0; r < i.length; r++)
        if (e.toLowerCase() === i[r].toLowerCase())
          return r;
    }
    throw TypeError("Invalid week day");
  },
  /**
   * Return name of the month
   * @param {Number|Date} date
   * @return {String}
   */
  getMonthName(e) {
    if (typeof e == "object")
      return m(e, "LLLL", { locale: this.language });
    if (typeof e == "number")
      return m($(/* @__PURE__ */ new Date(), e), "LLLL", { locale: this.language });
    throw TypeError("Invalid type");
  },
  /**
   * Return an abbreviated version of the month
   * @param {Number|Date} date
   * @return {String}
   */
  getMonthNameAbbr(e) {
    if (typeof e == "object")
      return m(e, "LLL", { locale: this.language });
    if (typeof e == "number")
      return m($(/* @__PURE__ */ new Date(), e), "LLL", { locale: this.language });
    throw TypeError("Invalid type");
  },
  /**
   * Alternative get total number of days in month
   * @param {Number} year
   * @param {Number} month
   * @return {Number}
   */
  daysInMonth(e, t) {
    return /8|3|5|10/.test(t) ? 30 : t === 1 ? !(e % 4) && e % 100 || !(e % 400) ? 29 : 28 : 31;
  },
  /**
   * Get nth suffix for date
   * @param {Number} day
   * @return {String}
   */
  getNthSuffix(e) {
    switch (e) {
      case 1:
      case 21:
      case 31:
        return "st";
      case 2:
      case 22:
        return "nd";
      case 3:
      case 23:
        return "rd";
      default:
        return "th";
    }
  },
  /**
   * Return abbreviated week day name
   * @param {Number} firstDayOfWeek
   * @param {Boolean} twoLetter
   * @returns {Array}
   */
  getDaysStartingOn(e, t = !1) {
    const s = /* @__PURE__ */ new Date(), i = [0, 1, 2, 3, 4, 5, 6];
    let r = "ccc";
    return t && (r = "cccccc"), i.map((a) => m(
      N(s, a + e),
      r,
      { locale: this.language }
    ));
  },
  /**
   * Formats date object
   * @param {Date} date
   * @param {String} formatString
   * @return {String}
   */
  formatDate(e, t) {
    return m(e, t, { locale: this.language });
  },
  /**
   * Parses a date from a string
   * @param {String}          dateStr
   * @param {Strin}           formatString
   * @return {Date}
   */
  parseDate(e, t = "yyyy-MM-dd") {
    if (typeof e == "string")
      return Q(e, t, /* @__PURE__ */ new Date(), { locale: this.language });
    if (typeof e == "number")
      return G(e);
  },
  /**
   * method used as a prop validator for input values
   * @param {*} val
   * @return {Boolean}
   */
  validateDateInput(e) {
    return e === null || e instanceof Date || typeof e == "string" || typeof e == "number";
  },
  /**
   * Remove hours/minutes/seconds/milliseconds from a date object
   * @param {Date} date
   * @return {Date}
   */
  resetDateTime(e) {
    return new Date(
      this.useUtc ? e.setUTCHours(0, 0, 0, 0) : e.setHours(0, 0, 0, 0)
    );
  },
  /**
   * Return a new date object with hours/minutes/seconds/milliseconds removed.
   * Defaults to today's date, if no parameter is provided
   * @param {Date=} date
   * @return {Date}
   */
  getNewDateObject(e) {
    return e ? this.resetDateTime(new Date(e)) : this.resetDateTime(/* @__PURE__ */ new Date());
  }
}, p = (e = !1, t = S) => ({ ...K, useUtc: e, language: t }), R = {
  ...K
}, z = ["dv", "fa", "ha", "he", "kwh", "ks", "ku", "ps", "ur", "yi"], Ne = ["ja", "lt", "mn", "ko"], H = {
  zh: "年",
  ja: "年",
  ko: "년"
}, J = {
  props: {
    autofocus: {
      type: Boolean,
      default: !1
    },
    bootstrapStyling: {
      type: Boolean,
      default: !1
    },
    clearButton: {
      type: Boolean,
      default: !1
    },
    clearButtonIcon: {
      type: String,
      default: null
    },
    calendarButton: {
      type: Boolean,
      default: !1
    },
    calendarButtonIcon: {
      type: String,
      default: null
    },
    calendarButtonIconContent: {
      type: String,
      default: null
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    format: {
      type: [String, Function],
      default: "dd MMM yyyy"
    },
    id: {
      type: String,
      default: null
    },
    inline: {
      type: Boolean,
      default: !1
    },
    inputClass: {
      type: [String, Object, Array],
      default: null
    },
    maxlength: {
      type: [Number, String],
      default: null
    },
    name: {
      type: String,
      default: null
    },
    pattern: {
      type: String,
      default: null
    },
    placeholder: {
      type: String,
      default: null
    },
    refName: {
      type: String,
      default: ""
    },
    required: {
      type: Boolean,
      default: !1
    },
    showCalendarOnFocus: {
      type: Boolean,
      default: !1
    },
    tabindex: {
      type: [Number, String],
      default: null
    },
    typeable: {
      type: Boolean,
      default: !1
    },
    useUtc: {
      type: Boolean,
      default: !1
    }
  }
}, M = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [i, r] of t)
    s[i] = r;
  return s;
}, Ve = {
  name: "DateInput",
  mixins: [J],
  props: {
    isOpen: {
      type: Boolean,
      default: !1
    },
    language: {
      type: Object
    },
    openDate: Date,
    parseTypedDate: Function,
    resetTypedDate: [Date],
    selectedDate: {
      type: Date,
      default: null
    }
  },
  emits: {
    clearDate: null,
    closeCalendar: null,
    open: null,
    selectTypedDate: (e) => e === null || e instanceof Date,
    setFocus: (e) => e.every((t) => [
      "calendarButton",
      "input",
      "prev",
      "up",
      "next",
      "tabbableCell"
    ].includes(t)),
    typedDate: (e) => e === null || e instanceof Date
  },
  data() {
    return {
      input: null,
      typedDate: !1,
      utils: p(this.useUtc, this.language)
    };
  },
  computed: {
    formattedValue() {
      return this.selectedDate ? this.typedDate ? this.typedDate : typeof this.format == "function" ? this.format(this.selectedDate) : this.utils.formatDate(this.selectedDate, this.format) : null;
    },
    computedInputClass() {
      return this.bootstrapStyling ? typeof this.inputClass == "string" ? [this.inputClass, "form-control"].join(" ") : { "form-control": !0, ...this.inputClass } : this.inputClass;
    }
  },
  watch: {
    language(e) {
      this.utils = p(this.useUtc, e);
    },
    useUtc(e) {
      this.utils = p(e, this.language);
    },
    resetTypedDate() {
      this.typedDate = !1;
    }
  },
  mounted() {
    this.input = this.$el.querySelector("input");
  },
  methods: {
    /**
     * Toggles the calendar (unless `show-calendar-on-focus` is true)
     */
    showCalendar() {
      this.showCalendarOnFocus || this.toggle();
    },
    /**
     * Opens the calendar when `show-calendar-on-focus` is true
     */
    showFocusCalendar() {
      this.showCalendarOnFocus && !this.isOpen && this.$emit("open");
    },
    /**
     * Opens the calendar, or sets the focus to the next focusable element down
     */
    handleKeydownDown() {
      this.isOpen || this.$emit("open"), this.typeable && this.$emit("setFocus", ["prev", "up", "next", "tabbableCell"]);
    },
    /**
     * Selects a typed date and closes the calendar
     */
    handleKeydownEnter() {
      if (!this.typeable)
        return;
      if (!this.input.value) {
        this.$emit("selectTypedDate", null);
        return;
      }
      const e = this.getTypedDate(this.input.value);
      isNaN(e) || (this.typedDate = this.input.value, this.$emit("selectTypedDate", e));
    },
    /**
     * Closes the calendar
     */
    handleKeydownEscape() {
      this.$emit("closeCalendar");
    },
    /**
     * Prevents scrolling when not typeable
     */
    handleKeydownSpace(e) {
      this.typeable || e.preventDefault();
    },
    /**
     * Attempt to parse a typed date
     * @param {Event} event
     */
    keyUp(e) {
      if (!this.typeable || [
        "Control",
        "Escape",
        "Shift",
        "Tab",
        "ArrowUp",
        "ArrowDown",
        "ArrowLeft",
        "ArrowRight"
      ].includes(e.key))
        return;
      if (this.typedDate = this.input.value, !this.input.value) {
        this.$emit("typedDate", null);
        return;
      }
      const t = this.getTypedDate(this.input.value);
      isNaN(t) || this.$emit("typedDate", t);
    },
    /**
     * Toggles the calendar unless a typed date has been entered
     */
    handleKeyupSpace(e) {
      if (this.typeable) {
        this.input.value === "" && this.toggle();
        return;
      }
      e.preventDefault(), this.toggle();
    },
    /**
     * nullify the typed date to defer to regular formatting
     * called once the input is blurred
     */
    inputBlurred() {
      this.typeable && isNaN(this.getTypedDate(this.input.value)) && (this.clearDate(), this.input.value = null, this.typedDate = null);
    },
    /**
     * Clears the calendar when the `delete` or `backspace` key is pressed
     */
    handleDelete() {
      !this.typeable && this.selectedDate && this.clearDate();
    },
    /**
     * Emits a `clear-date` event
     */
    clearDate() {
      this.input.value = "", this.$emit("clearDate");
    },
    /**
     * parse Date with regular or custom function
     */
    getTypedDate(e) {
      return typeof this.parseTypedDate == "function" ? this.parseTypedDate(e) : this.utils.parseDate(e, typeof this.format == "string" ? this.format : void 0);
    },
    /**
     * Opens or closes the calendar
     */
    toggle(e) {
      this.isOpen && this.$emit("setFocus", [e || "input"]), this.$emit(this.isOpen ? "closeCalendar" : "open");
    }
  }
}, Ae = ["disabled"], Be = { key: 0 }, Ue = ["id", "autofocus", "clear-button", "disabled", "maxlength", "name", "open-date", "pattern", "placeholder", "readonly", "required", "tabindex", "type", "value"], Ye = ["disabled"], He = { key: 0 };
function We(e, t, s, i, r, a) {
  return h(), f("div", {
    class: c({ "input-group": e.bootstrapStyling })
  }, [
    e.calendarButton ? (h(), f("button", {
      key: 0,
      ref: "calendarButton",
      class: c(["vdp-datepicker__calendar-button", { "btn input-group-prepend": e.bootstrapStyling }]),
      disabled: e.disabled,
      onClick: t[0] || (t[0] = (n) => a.toggle("calendarButton"))
    }, [
      y("span", {
        class: c({ "input-group-text": e.bootstrapStyling })
      }, [
        g(e.$slots, "calendarBtn", {}, () => [
          y("i", {
            class: c(e.calendarButtonIcon)
          }, [
            v(D(e.calendarButtonIconContent) + " ", 1),
            e.calendarButtonIcon ? E("", !0) : (h(), f("span", Be, "…"))
          ], 2)
        ])
      ], 2)
    ], 10, Ae)) : E("", !0),
    g(e.$slots, "beforeDateInput"),
    y("input", {
      id: e.id,
      ref: e.refName,
      autocomplete: "off",
      autofocus: e.autofocus,
      class: c(a.computedInputClass),
      "clear-button": e.clearButton,
      disabled: e.disabled,
      maxlength: e.maxlength,
      name: e.name,
      "open-date": s.openDate,
      pattern: e.pattern,
      placeholder: e.placeholder,
      readonly: !e.typeable,
      required: e.required,
      tabindex: e.tabindex,
      type: e.inline ? "hidden" : "text",
      value: a.formattedValue,
      onBlur: t[1] || (t[1] = (...n) => a.inputBlurred && a.inputBlurred(...n)),
      onClick: t[2] || (t[2] = (...n) => a.showCalendar && a.showCalendar(...n)),
      onFocus: t[3] || (t[3] = (...n) => a.showFocusCalendar && a.showFocusCalendar(...n)),
      onKeydown: [
        t[4] || (t[4] = u((...n) => a.handleDelete && a.handleDelete(...n), ["delete"])),
        t[5] || (t[5] = u(d((...n) => a.handleKeydownDown && a.handleKeydownDown(...n), ["prevent"]), ["down"])),
        t[6] || (t[6] = u(d((...n) => a.handleKeydownEnter && a.handleKeydownEnter(...n), ["prevent"]), ["enter"])),
        t[7] || (t[7] = u(d((...n) => a.handleKeydownEscape && a.handleKeydownEscape(...n), ["prevent"]), ["esc"])),
        t[8] || (t[8] = u((n) => a.handleKeydownSpace(n), ["space"]))
      ],
      onKeyup: [
        t[9] || (t[9] = (...n) => a.keyUp && a.keyUp(...n)),
        t[10] || (t[10] = u((n) => a.handleKeyupSpace(n), ["space"]))
      ]
    }, null, 42, Ue),
    e.clearButton && s.selectedDate ? (h(), f("button", {
      key: 1,
      class: c(["vdp-datepicker__clear-button", { "btn input-group-append": e.bootstrapStyling }]),
      disabled: e.disabled,
      onClick: t[11] || (t[11] = (...n) => a.clearDate && a.clearDate(...n))
    }, [
      y("span", {
        class: c({ "input-group-text": e.bootstrapStyling })
      }, [
        g(e.$slots, "clearBtn", {}, () => [
          y("i", {
            class: c(e.clearButtonIcon)
          }, [
            e.clearButtonIcon ? E("", !0) : (h(), f("span", He, "×"))
          ], 2)
        ])
      ], 2)
    ], 10, Ye)) : E("", !0),
    g(e.$slots, "afterDateInput")
  ], 2);
}
const Le = /* @__PURE__ */ M(Ve, [["render", We]]), xe = {
  isDefined(e, t) {
    return e && typeof e[t] < "u";
  },
  hasArray(e, t) {
    return e && Array.isArray(e[t]);
  },
  hasDate(e, t) {
    return this.isDefined(e, t) && this.utils.isValidDate(e[t]);
  },
  dayMonthYear(e, t) {
    const { utils: s } = this;
    if (!this.hasDate(e, t))
      return {
        day: void 0,
        month: void 0,
        year: void 0
      };
    const r = e[t];
    return {
      day: s.getDate(r),
      month: s.getMonth(r),
      year: s.getFullYear(r)
    };
  }
}, I = (e) => ({
  ...xe,
  utils: e
});
class w {
  constructor(t, s) {
    this._utils = t, this._disabledDates = s;
  }
  get config() {
    const t = this._disabledDates, s = I(this._utils), i = {
      customPredictor: s.isDefined(t, "customPredictor"),
      daysOfMonth: s.hasArray(t, "daysOfMonth"),
      daysOfWeek: s.hasArray(t, "days"),
      from: s.hasDate(t, "from"),
      ranges: s.hasArray(t, "ranges"),
      specificDates: s.hasArray(t, "dates"),
      to: s.hasDate(t, "to")
    };
    return {
      to: s.dayMonthYear(t, "to"),
      from: s.dayMonthYear(t, "from"),
      has: i
    };
  }
  daysInMonth(t) {
    const s = this._utils, i = s.getMonth(t), r = s.getFullYear(t);
    return s.daysInMonth(r, i);
  }
  isDateDisabledVia(t) {
    const s = this._disabledDates, { has: i } = this.config;
    return {
      to: () => i.to && t < s.to,
      from: () => i.from && t > s.from,
      range: () => {
        if (!i.ranges) return !1;
        const { ranges: r } = s, a = I(this._utils);
        return r.some((n) => {
          const o = a.isDefined(n, "from"), l = a.isDefined(n, "to");
          return o && l && t < n.to && t > n.from;
        });
      },
      customPredictor: () => i.customPredictor && s.customPredictor(t),
      specificDate: () => i.specificDates ? s.dates.some((r) => this._utils.compareDates(t, r)) : !1,
      daysOfWeek: () => i.daysOfWeek ? s.days.indexOf(this._utils.getDay(t)) !== -1 : !1,
      daysOfMonth: () => i.daysOfMonth ? s.daysOfMonth.indexOf(this._utils.getDate(t)) !== -1 : !1
    };
  }
  isMonthDisabledVia(t) {
    const { from: s, has: i, to: r } = this.config, a = this._utils.getMonth(t), n = this._utils.getFullYear(t);
    return {
      to: () => i.to && n < r.year ? !0 : i.to && a < r.month && n <= r.year,
      from: () => i.from && n > s.year ? !0 : i.from && a > s.month && n >= s.year
    };
  }
  isYearDisabledVia(t) {
    const { from: s, has: i, to: r } = this.config, a = this._utils.getFullYear(t);
    return {
      to: () => i.to && a < r.year,
      from: () => i.from && a > s.year
    };
  }
  /**
   * Checks if the given date should be disabled
   * @param {Date} date
   * @return {Boolean}
   */
  isDateDisabled(t) {
    const s = this.isDateDisabledVia(t);
    return s.to() || s.from() || s.range() || s.specificDate() || s.daysOfWeek() || s.daysOfMonth() || s.customPredictor();
  }
  /**
   * Checks if the given month should be disabled
   * @param {Date} date
   * @return {Boolean}
   */
  isMonthDisabled(t) {
    const s = this.isMonthDisabledVia(t);
    if (s.to() || s.from())
      return !0;
    for (let i = 1; i <= this.daysInMonth(t); i++) {
      const r = new Date(t);
      if (r.setDate(i), !this.isDateDisabled(r))
        return !1;
    }
    return !0;
  }
  /**
   * Checks if the given year should be disabled
   * @param {Date} date
   * @return {Boolean}
   */
  isYearDisabled(t) {
    const s = this.isYearDisabledVia(t);
    if (s.to() || s.from())
      return !0;
    for (let i = 0; i < 12; i++) {
      const r = new Date(t);
      if (r.setMonth(i), !this.isMonthDisabled(r))
        return !1;
    }
    return !0;
  }
  getEarliestPossibleDate(t) {
    if (!t)
      return null;
    const s = this._utils;
    if (this.isDateDisabled(t)) {
      const i = new Date(
        s.getFullYear(t),
        s.getMonth(t),
        s.getDate(t) + 1
      );
      return this.getEarliestPossibleDate(i);
    }
    return t;
  }
  getLatestPossibleDate(t) {
    const s = this.isYearDisabledVia(t);
    if (s.to() || s.from())
      return !0;
    for (let i = 0; i < 12; i++) {
      const r = new Date(t);
      if (r.setMonth(i), !this.isMonthDisabled(r))
        return !1;
    }
    return !0;
  }
}
const $e = {
  data() {
    return {
      focus: {
        delay: 0,
        refs: []
      },
      inlineTabbableCell: null,
      navElements: [],
      navElementsFocusedIndex: 0,
      resetTabbableCell: !1,
      tabbableCell: null
    };
  },
  computed: {
    fallbackElementsToFocus() {
      const e = ["tabbableCell", "prev", "next"];
      return this.typeable && e.unshift("input"), e;
    },
    tabbableCellId() {
      return this.tabbableCell && Number(this.tabbableCell.getAttribute("data-id"));
    }
  },
  methods: {
    /**
     * Converts a date to first in month for `month` view or first in year for `year` view
     * @param   {Date} date The date to convert
     * @returns {Date}
     */
    getCellDate(e) {
      switch (this.view) {
        case "month":
          return new Date(this.utils.setDate(e, 1));
        case "year":
          return new Date(
            this.utils.setMonth(new Date(this.utils.setDate(e, 1)), 0)
          );
        default:
          return e;
      }
    },
    /**
     * Returns true, unless tabbing should be focus-trapped
     * @return {Boolean}
     */
    allowNormalTabbing(e) {
      return this.isOpen ? this.isTabbingAwayFromInlineDatepicker(e) : !0;
    },
    /**
     * Focuses the first non-disabled element found in the `focus.refs` array and sets `navElementsFocusedIndex`
     */
    applyFocus() {
      const e = [...this.focus.refs, ...this.fallbackElementsToFocus];
      for (let t = 0; t < e.length; t++) {
        const s = this.getElementByRef(e[t]);
        if (s && s.getAttribute("disabled") === null) {
          s.focus(), this.setNavElementsFocusedIndex();
          break;
        }
      }
    },
    /**
     * Returns the currently focused cell element, if there is one...
     */
    getActiveCell() {
      const e = this.getActiveElement(), t = this.hasClass(e, "cell"), s = this.hasClass(e, this.view);
      return t && s && !this.resetTabbableCell ? e : null;
    },
    /**
     * Returns the currently focused element, using shadowRoot for web-components...
     */
    getActiveElement() {
      return document.activeElement.shadowRoot ? document.activeElement.shadowRoot.activeElement : document.activeElement;
    },
    /**
     * Returns the `cellId` for a given a date
     * @param {Date} date The date for which we need the cellId
     * @returns {Number|null}
     */
    getCellId(e) {
      if (!e || !this.$refs.picker.$refs.cells)
        return null;
      const t = this.getCellDate(e), { cells: s } = this.$refs.picker.$refs.cells;
      for (let i = 0; i < s.length; i++)
        if (s[i].timestamp === t.valueOf())
          return i;
      return null;
    },
    /**
     * Finds an element by its `ref` attribute
     * @param {string} ref        The `ref` name of the wanted element
     * @returns {HTMLElement|Vue} A Vue element
     */
    getElementByRef(e) {
      return e === "tabbableCell" ? this.tabbableCell : e === "input" ? this.$refs.dateInput && this.$refs.dateInput.$refs[this.refName] : e === "calendarButton" ? this.$refs.dateInput && this.$refs.dateInput.$refs.calendarButton : this.$refs.picker && this.$refs.picker.$refs.pickerHeader && this.$refs.picker.$refs.pickerHeader.$refs[e];
    },
    /**
     * Returns an array of all HTML elements which should be focus-trapped in the specified slot
     * @returns {Array}   An array of HTML elements
     */
    getElementsFromSlot(e) {
      if (!this.hasSlot(e))
        return [];
      if (e === "beforeCalendarHeader")
        return this.getFocusableElements(this.$refs.view.children[0]);
      const t = e.indexOf("beforeCalendarHeader") > -1, s = this.$refs.picker.$el, i = t ? 0 : s.children.length - 1;
      return this.getFocusableElements(s.children[i]);
    },
    /**
     * Returns an array of all HTMLButtonElements which should be focus-trapped in the header
     * @returns {Array}   An array of HTMLButtonElements
     */
    getElementsFromHeader() {
      if (!this.$refs.picker.$refs.pickerHeader)
        return [];
      const t = this.$refs.picker.$refs.pickerHeader.$el.querySelectorAll("button:enabled");
      return [...Array.prototype.slice.call(t)];
    },
    /**
     * Returns an array of focusable elements in a given HTML fragment
     * @param   {Element} fragment The HTML fragment to search
     * @returns {Array}
     */
    getFocusableElements(e) {
      if (!e)
        return [];
      const t = e.querySelectorAll(
        'button:enabled:not([tabindex="-1"]), [href]:not([tabindex="-1"]), input:not([tabindex="-1"]):not([type=hidden]), select:enabled:not([tabindex="-1"]), textarea:enabled:not([tabindex="-1"]), [tabindex]:not([tabindex="-1"])'
      );
      return [...Array.prototype.slice.call(t)];
    },
    /**
     * Returns the first focusable element of an inline datepicker
     * @returns {HTMLElement}
     */
    getFirstInlineFocusableElement() {
      return this.getFocusableElements(this.$refs.picker.$el)[0];
    },
    /**
     * Returns the last focusable element of an inline datepicker
     * @returns {HTMLElement}
     */
    getLastInlineFocusableElement() {
      const e = this.getFocusableElements(this.$refs.picker.$el);
      return e[e.length - 1];
    },
    /**
     * Returns the input element (when typeable)
     * @returns {Element}
     */
    getInputField() {
      return !this.typeable || this.inline ? null : this.$refs.dateInput.$refs[this.refName];
    },
    /**
     * Used for a typeable datepicker: returns the cell element that corresponds to latestValidTypedDate...
     */
    getTypedCell() {
      if (!this.typeable)
        return null;
      const e = this.getCellId(this.latestValidTypedDate);
      return e ? this.$refs.picker.$refs.cells.$el.children[e] : null;
    },
    /**
     * Returns true if the calendar has been passed the given slot
     * @param  {String} slotName The name of the slot
     * @return {Boolean}
     */
    hasSlot(e) {
      return !!this.$slots[e];
    },
    /**
     * Returns true if the user is tabbing away from an inline datepicker
     * @return {Boolean}
     */
    isTabbingAwayFromInlineDatepicker(e) {
      return this.inline ? this.isTabbingAwayFromFirstNavElement(e) ? (this.tabAwayFromFirstElement(), !0) : this.isTabbingAwayFromLastNavElement(e) ? (this.tabAwayFromLastElement(), !0) : !1 : !1;
    },
    /**
     * Used for inline calendars; returns true if the user tabs backwards from the first focusable element
     * @param  {object}  event Used to determine whether we are tabbing forwards or backwards
     * @return {Boolean}
     */
    isTabbingAwayFromFirstNavElement(e) {
      if (!e.shiftKey)
        return !1;
      const t = this.getActiveElement(), s = this.navElements[0];
      return t === s;
    },
    /**
     * Used for inline calendars; returns true if the user tabs forwards from the last focusable element
     * @param  {object}  event Used to determine whether we are tabbing forwards or backwards
     * @return {Boolean}
     */
    isTabbingAwayFromLastNavElement(e) {
      if (e.shiftKey)
        return !1;
      const t = this.getActiveElement(), s = this.navElements[this.navElements.length - 1];
      return t === s;
    },
    /**
     * Sets the correct focus on next tick
     */
    reviewFocus() {
      this.tabbableCell = null, this.resetTabbableCell = !0, this.$nextTick(() => {
        this.setNavElements(), setTimeout(() => {
          this.applyFocus();
        }, this.focus.delay), this.resetTabbableCell = !1;
      });
    },
    /**
     * Stores the current tabbableCell of an inline datepicker
     * N.B. This is used when tabbing back (shift + tab) to an inline calendar from further down the page
     */
    setInlineTabbableCell() {
      this.inline && (this.inlineTabbableCell = this.tabbableCell);
    },
    /**
     * Set the focus
     * @param {Array} refs An array of `refs` to focus (in order of preference)
     */
    setFocus(e) {
      this.focus.refs = e, this.applyFocus();
    },
    /**
     * Determines which elements in datepicker should be focus-trapped
     */
    setNavElements() {
      if (!this.view) return;
      this.updateTabbableCell();
      const e = this.ucFirst(this.view);
      this.navElements = [
        this.getInputField(),
        this.getElementsFromSlot("beforeCalendarHeader"),
        this.getElementsFromSlot(`beforeCalendarHeader${e}`),
        this.getElementsFromHeader(),
        this.tabbableCell
      ].filter((t) => !!t).reduce((t, s) => t.concat(s), []);
    },
    /**
     * Keeps track of the currently focused index in the navElements array
     */
    setNavElementsFocusedIndex() {
      const e = this.getActiveElement();
      for (let t = 0; t < this.navElements.length; t++)
        if (e === this.navElements[t]) {
          this.navElementsFocusedIndex = t;
          return;
        }
      this.navElementsFocusedIndex = 0;
    },
    /**
     * Sets the focus-trapped cell in the picker
     */
    setTabbableCell() {
      if (!this.$refs.picker || !this.$refs.picker.$refs.cells)
        return;
      const e = this.$refs.picker.$refs.cells.$el;
      this.tabbableCell = this.getActiveCell() || this.getTypedCell() || e.querySelector("button.selected:not(.muted):enabled") || e.querySelector("button.today:not(.muted):enabled") || e.querySelector("button.cell:not(.muted):enabled");
    },
    /**
     * Focuses the first focusable element of an inline datepicker, so that the previous element on the page will be tabbed to
     */
    tabAwayFromFirstElement() {
      this.getFirstInlineFocusableElement().focus(), this.tabbableCell = this.inlineTabbableCell;
    },
    /**
     * Focuses the last focusable element of an inline datepicker, so that the next element on the page will be tabbed to
     */
    tabAwayFromLastElement() {
      this.getLastInlineFocusableElement().focus(), this.tabbableCell = this.inlineTabbableCell;
    },
    /**
     * Tab backwards through the focus-trapped elements
     */
    tabBackwards() {
      this.navElementsFocusedIndex -= 1, this.navElementsFocusedIndex < 0 && (this.navElementsFocusedIndex = this.navElements.length - 1), this.navElements[this.navElementsFocusedIndex].focus();
    },
    /**
     * Tab forwards through the focus-trapped elements
     */
    tabForwards() {
      this.navElementsFocusedIndex += 1, this.navElementsFocusedIndex >= this.navElements.length && (this.navElementsFocusedIndex = 0), this.navElements[this.navElementsFocusedIndex].focus();
    },
    /**
     * Tab through the focus-trapped elements
     * @param event
     */
    tabThroughNavigation(e) {
      this.allowNormalTabbing(e) || (e.preventDefault(), e.shiftKey ? this.tabBackwards() : this.tabForwards());
    },
    /**
     * Update which cell in the picker should be focus-trapped
     */
    updateTabbableCell() {
      const e = this.getActiveElement(), t = this.hasClass(e, "cell");
      (!this.tabbableCell || t) && this.setTabbableCell();
    }
  }
}, Re = {
  props: {
    bootstrapStyling: {
      type: Boolean,
      default: !1
    },
    isNextDisabled: {
      type: Boolean,
      required: !0
    },
    isPreviousDisabled: {
      type: Boolean,
      required: !0
    },
    isRtl: {
      type: Boolean,
      required: !0
    },
    isUpDisabled: {
      type: Boolean,
      default: !1
    },
    nextViewUp: {
      type: String,
      default: null
    },
    upButtonClasses: {
      type: String
    }
  },
  emits: {
    focusInput: null,
    pageChange: (e) => typeof e == "object",
    setFocus: (e) => e.every((t) => ["input", "prev", "up", "next", "tabbableCell"].includes(t)),
    setView: (e) => ["day", "month", "year"].includes(e)
  },
  computed: {
    leftButton() {
      return [this.isRtl ? "next" : "prev"];
    },
    rightButton() {
      return [this.isRtl ? "prev" : "next"];
    }
  },
  methods: {
    /**
     * Changes the page, or sets focus to the adjacent button
     */
    arrowLeftPrev() {
      if (this.isRtl) {
        this.$emit("setFocus", ["up", "next", "tabbableCell"]);
        return;
      }
      this.goToPreviousPage();
    },
    /**
     * Changes the page, or sets focus to the adjacent button
     */
    arrowRightPrev() {
      if (this.isRtl) {
        this.goToPreviousPage();
        return;
      }
      this.$emit("setFocus", ["up", "next", "tabbableCell"]);
    },
    /**
     * Changes the page, or sets focus to the adjacent button
     */
    arrowLeftNext() {
      if (this.isRtl) {
        this.goToNextPage();
        return;
      }
      this.$emit("setFocus", ["up", "prev", "tabbableCell"]);
    },
    /**
     * Changes the page, or sets focus to the adjacent button
     */
    arrowRightNext() {
      if (this.isRtl) {
        this.$emit("setFocus", ["up", "prev", "tabbableCell"]);
        return;
      }
      this.goToNextPage();
    },
    focusInput() {
      this.$emit("focusInput");
    },
    focusTabbableCell() {
      this.$emit("setFocus", ["tabbableCell"]);
    },
    focusLeftButton() {
      this.$emit("setFocus", this.leftButton);
    },
    focusRightButton() {
      this.$emit("setFocus", this.rightButton);
    },
    goToNextPage() {
      this.$emit("pageChange", { incrementBy: 1, focusRefs: ["next"] });
    },
    goToPreviousPage() {
      this.$emit("pageChange", { incrementBy: -1, focusRefs: ["prev"] });
    },
    selectUpButton() {
      this.isUpDisabled || this.$emit("setView", this.nextViewUp);
    }
  }
}, je = ["disabled"], qe = {
  key: 1,
  ref: "up"
}, Ke = ["disabled"];
function ze(e, t, s, i, r, a) {
  return h(), f("header", null, [
    y("button", {
      ref: "prev",
      class: c(["prev", { btn: s.bootstrapStyling, rtl: s.isRtl }]),
      disabled: s.isPreviousDisabled,
      type: "button",
      onClick: t[0] || (t[0] = (n) => s.isRtl ? a.goToNextPage() : a.goToPreviousPage()),
      onKeydown: [
        t[1] || (t[1] = u(d((...n) => a.focusTabbableCell && a.focusTabbableCell(...n), ["prevent"]), ["down"])),
        t[2] || (t[2] = u(d((...n) => a.focusInput && a.focusInput(...n), ["prevent"]), ["up"])),
        t[3] || (t[3] = u(d((...n) => a.arrowLeftPrev && a.arrowLeftPrev(...n), ["prevent"]), ["left"])),
        t[4] || (t[4] = u(d((...n) => a.arrowRightPrev && a.arrowRightPrev(...n), ["prevent"]), ["right"]))
      ]
    }, "<", 42, je),
    s.isUpDisabled ? (h(), f("span", qe, [
      g(e.$slots, "default")
    ], 512)) : (h(), f("button", {
      key: 0,
      ref: "up",
      class: c([s.upButtonClasses, "up", { btn: s.bootstrapStyling }]),
      type: "button",
      onClick: t[5] || (t[5] = (...n) => a.selectUpButton && a.selectUpButton(...n)),
      onKeydown: [
        t[6] || (t[6] = u(d((...n) => a.focusTabbableCell && a.focusTabbableCell(...n), ["prevent"]), ["down"])),
        t[7] || (t[7] = u(d((...n) => a.focusInput && a.focusInput(...n), ["prevent"]), ["up"])),
        t[8] || (t[8] = u(d((...n) => a.focusLeftButton && a.focusLeftButton(...n), ["prevent"]), ["left"])),
        t[9] || (t[9] = u(d((...n) => a.focusRightButton && a.focusRightButton(...n), ["prevent"]), ["right"]))
      ]
    }, [
      g(e.$slots, "default")
    ], 34)),
    y("button", {
      ref: "next",
      class: c(["next", { btn: s.bootstrapStyling, rtl: s.isRtl }]),
      disabled: s.isNextDisabled,
      type: "button",
      onClick: t[10] || (t[10] = (n) => s.isRtl ? a.goToPreviousPage() : a.goToNextPage()),
      onKeydown: [
        t[11] || (t[11] = u(d((...n) => a.focusTabbableCell && a.focusTabbableCell(...n), ["prevent"]), ["down"])),
        t[12] || (t[12] = u(d((...n) => a.focusInput && a.focusInput(...n), ["prevent"]), ["up"])),
        t[13] || (t[13] = u(d((...n) => a.arrowLeftNext && a.arrowLeftNext(...n), ["prevent"]), ["left"])),
        t[14] || (t[14] = u(d((...n) => a.arrowRightNext && a.arrowRightNext(...n), ["prevent"]), ["right"]))
      ]
    }, ">", 42, Ke)
  ]);
}
const W = /* @__PURE__ */ M(Re, [["render", ze]]), Je = {
  name: "PickerCells",
  props: {
    bootstrapStyling: {
      type: Boolean,
      default: !1
    },
    cells: {
      type: Array,
      required: !0
    },
    isRtl: {
      type: Boolean,
      default: !1
    },
    showEdgeDates: {
      type: Boolean,
      default: !0
    },
    tabbableCellId: {
      type: Number,
      default: null
    },
    view: {
      type: String,
      validator: (e) => ["day", "month", "year"].includes(e),
      required: !0
    }
  },
  emits: {
    arrow(e) {
      return typeof e == "object";
    },
    select(e) {
      return typeof e == "object";
    }
  },
  computed: {
    /**
     * The number of columns in the picker
     * @return {Number}
     */
    columns() {
      return this.view === "day" ? 7 : 3;
    }
  },
  methods: {
    /**
     * Set the classes for a specific cell
     * @return {Array}
     */
    cellClasses(e) {
      return [
        "cell",
        this.view,
        {
          blank: e.date === "",
          btn: this.bootstrapStyling,
          disabled: e.isDisabled,
          "highlight-start": e.isHighlightStart,
          "highlight-end": e.isHighlightEnd,
          highlighted: e.isHighlighted,
          muted: e.isPreviousMonth || e.isNextMonth,
          sat: e.isSaturday,
          sun: e.isSunday,
          selected: this.showEdgeDates ? e.isSelected : e.isSelected && !e.isPreviousMonth && !e.isNextMonth,
          today: this.showEdgeDates ? e.isToday : e.isToday && !e.isPreviousMonth && !e.isNextMonth,
          weekend: e.isWeekend
        }
      ];
    },
    /**
     * Emits an `arrow` event
     */
    handleArrow(e, t) {
      this.$emit("arrow", { cellId: e, delta: t });
    }
  }
}, Xe = { class: "picker-cells" }, Qe = ["data-id", "disabled", "onClick", "onKeypress", "onKeydown"];
function Ge(e, t, s, i, r, a) {
  return h(), f("div", Xe, [
    (h(!0), f(j, null, q(s.cells, (n, o) => (h(), f("button", {
      key: n.timestamp,
      class: c(a.cellClasses(n)),
      "data-id": o,
      disabled: n.isDisabled,
      type: "button",
      onClick: (l) => e.$emit("select", n),
      onKeypress: [
        u((l) => e.$emit("select", n), ["enter"]),
        u((l) => e.$emit("select", n), ["space"])
      ],
      onKeydown: [
        u(d((l) => a.handleArrow(o, -a.columns), ["prevent"]), ["up"]),
        u(d((l) => a.handleArrow(o, a.columns), ["prevent"]), ["down"]),
        u(d((l) => a.handleArrow(o, s.isRtl ? 1 : -1), ["prevent"]), ["left"]),
        u(d((l) => a.handleArrow(o, s.isRtl ? -1 : 1), ["prevent"]), ["right"])
      ]
    }, [
      g(e.$slots, "default", { cell: n })
    ], 42, Qe))), 128))
  ]);
}
const L = /* @__PURE__ */ M(Je, [["render", Ge]]), x = {
  props: {
    bootstrapStyling: {
      type: Boolean,
      default: !1
    },
    calendarClass: [String, Object, Array],
    calendarStyle: {
      type: Object
    },
    disabledDates: {
      type: Object
    },
    isTypeable: {
      type: Boolean,
      default: !1
    },
    isUpDisabled: {
      type: Boolean,
      default: !1
    },
    language: {
      type: Object
    },
    pageDate: {
      type: Date,
      default: null
    },
    selectedDate: {
      type: Date,
      default: null
    },
    slideDuration: {
      type: Number,
      default: 250
    },
    tabbableCellId: {
      type: Number,
      default: null
    },
    useUtc: {
      type: Boolean,
      default: !1
    },
    visible: {
      type: Boolean,
      default: !1
    }
  },
  emits: {
    select: (e) => typeof e == "object",
    selectedDisabled: (e) => typeof e == "object",
    setFocus: (e) => Array.isArray(e) && e.length === 1 && e[0] === "input"
  },
  data() {
    return {
      utils: p(this.useUtc, this.language)
    };
  },
  watch: {
    language(e) {
      this.utils = p(this.useUtc, e);
    },
    useUtc(e) {
      this.utils = p(e, this.language);
    }
  },
  computed: {
    /**
     * A look-up object created from 'disabledDates' prop
     * @return {Object}
     */
    disabledConfig() {
      return this.disabledDates ? new w(this.utils, this.disabledDates).config : {
        has: {
          from: !1,
          to: !1
        }
      };
    },
    earliestPossibleDate() {
      return this.disabledDates ? new w(
        this.utils,
        this.disabledDates
      ).getEarliestPossibleDate(this.disabledDates.to) : null;
    },
    isRtl() {
      return z.indexOf(this.language) !== -1;
    },
    latestPossibleDate() {
      return this.disabledDates ? new w(
        this.utils,
        this.disabledDates
      ).getLatestPossibleDate(this.disabledDates.from) : null;
    },
    /**
     * Returns the current page's full year as an integer.
     * @return {Number}
     */
    pageYear() {
      return this.utils.getFullYear(this.pageDate);
    }
  },
  methods: {
    /**
     * Used when an arrow key press would cause the focus to land on a disabled date
     * @param {Object} options
     */
    addMoreSteps(e) {
      return e.stepsRemaining <= 0 && Math.abs(e.delta) > 1 ? Math.abs(e.delta) : e.stepsRemaining;
    },
    /**
     * Changes the page and focuses the cell that is being 'arrowed' to
     * @param {Object} options
     */
    changePageAndSetFocus(e) {
      const { delta: t } = e;
      t > 0 && this.isNextDisabled || t < 0 && this.isPreviousDisabled || (this.changePage({
        incrementBy: Math.sign(t),
        focusRefs: ["arrow-to-cell"]
      }), this.$nextTick(() => {
        this.setFocusOnNewPage(e);
      }));
    },
    /**
     * Focuses the input field, if typeable
     */
    focusInput() {
      this.isTypeable && this.$emit("setFocus", ["input"]);
    },
    /**
     * Returns the element that should be focused when navigating via an arrow key
     * @param  {HTMLButtonElement} currentElement  The element currently being iterated on
     * @param  {Number}            delta           The number of cells that the focus should move
     * @param  {Number}            stepsRemaining  The number of steps remaining in the iteration
     * @return {HTMLButtonElement | void}
     */
    getElement({ currentElement: e, delta: t, stepsRemaining: s }) {
      const i = this.getElementSibling(e, t), r = {
        currentElement: i,
        delta: t,
        stepsRemaining: s - 1
      };
      return i ? this.isBeyondPossibleDate(r) ? this.firstOrLastPossibleDate(r) : this.isMutedOrDisabled(i) ? (r.stepsRemaining = this.addMoreSteps(r), this.getElement(r)) : s > 1 && r.currentElement ? this.getElement(r) : i : this.changePageAndSetFocus(r);
    },
    /**
     * Returns the element directly next to the currentElement
     * @param  {HTMLButtonElement} currentElement The element currently being iterated on
     * @param  {Number}            delta          The number of cells that the focus should move
     * @return {HTMLButtonElement}
     */
    getElementSibling(e, t) {
      return t > 0 ? e.nextElementSibling : e.previousElementSibling;
    },
    /**
     * Returns the first or last cell, depending on the direction of the search
     * @param  {Number} delta The number of cells that the focus should move
     * @return {HTMLButtonElement}
     */
    getFirstOrLastElement(e) {
      const t = e > 0, s = this.$refs.cells.$el.children;
      return t ? s[0] : s[s.length - 1];
    },
    /**
     * Returns the first or last non-disabled date, depending on the direction of the search
     * @param  {HTMLButtonElement} currentElement  The element currently being iterated on
     * @param  {Number}            delta           The number of cells that the focus should move
     */
    firstOrLastPossibleDate({ currentElement: e, delta: t }) {
      return t > 0 ? this.getElementSibling(e, -1) : this.getElementSibling(e, 1);
    },
    /**
     * Moves the focused cell up/down/left/right
     * @param {Object}
     */
    handleArrow({ delta: e }) {
      const t = document.activeElement.shadowRoot ? document.activeElement.shadowRoot.activeElement : document.activeElement, s = Math.abs(e), i = {
        currentElement: t,
        delta: e,
        stepsRemaining: s
      };
      this.setFocusToAvailableCell(i);
    },
    /**
     * Determines which transition to use (for edge dates) and emits a 'select' event
     * @param {Object} cell
     */
    select(e) {
      e.isDisabled ? this.$emit("selectedDisabled", e) : this.$emit("select", e);
    },
    /**
     * Returns true if the given element cannot be focused
     * @param  {HTMLButtonElement} currentElement  The element currently being iterated on
     * @param  {Number}            delta           The number of cells that the focus should move
     * @return {Boolean}
     */
    isBeyondPossibleDate({ currentElement: e, delta: t }) {
      return t > 0 && this.latestPossibleDate ? this.isDatePossible(e, t) : t < 0 && this.earliestPossibleDate ? this.isDatePossible(e, t) : !1;
    },
    /**
     * Returns true if the current element's date is NOT possible, given the `disabled-dates`
     * @param  {HTMLButtonElement} element The element in question
     * @param  {Number}            delta   Used to determine direction of travel
     * @return {Boolean}
     */
    isDatePossible(e, t) {
      const s = e.getAttribute("data-id"), i = new Date(this.cells[s].timestamp);
      return t > 0 ? i > this.latestPossibleDate : i < this.earliestPossibleDate;
    },
    /**
     * Returns true if the given element cannot be focused
     * @param  {HTMLButtonElement} element The element in question
     * @return {Boolean}
     */
    isMutedOrDisabled(e) {
      const t = e.classList.value.split(" ").includes("muted"), s = e.disabled;
      return t || s;
    },
    /**
     * Sets the focus on the correct cell following a page change
     * @param {Object} options
     */
    setFocusOnNewPage({ delta: e, stepsRemaining: t }) {
      const s = this.getFirstOrLastElement(e), i = {
        currentElement: s,
        delta: e,
        stepsRemaining: t
      };
      if (t <= 0) {
        if (this.isMutedOrDisabled(s)) {
          i.stepsRemaining = Math.abs(i.delta), setTimeout(() => {
            this.setFocusToAvailableCell(i);
          }, this.slideDuration);
          return;
        }
        setTimeout(() => {
          s.focus();
        }, this.slideDuration);
        return;
      }
      setTimeout(() => {
        this.setFocusToAvailableCell(i);
      }, this.slideDuration);
    },
    /**
     * Sets the focus on the next focusable cell when an arrow key is pressed
     * @param {Object} options
     */
    setFocusToAvailableCell(e) {
      const t = this.getElement(e);
      t && t.focus();
    }
  }
};
class A {
  constructor(t, s, i) {
    this._utils = t, this._disabledDates = s, this._highlighted = i;
  }
  get config() {
    const t = this._highlighted, s = I(this._utils), i = {
      customPredictor: s.isDefined(t, "customPredictor"),
      daysOfMonth: s.hasArray(t, "daysOfMonth"),
      daysOfWeek: s.hasArray(t, "days"),
      from: s.hasDate(t, "from"),
      ranges: s.hasArray(t, "ranges"),
      specificDates: s.hasArray(t, "dates"),
      to: s.hasDate(t, "to"),
      includeDisabled: s.isDefined(t, "includeDisabled") && t.includeDisabled
    };
    return {
      to: s.dayMonthYear(t, "to"),
      from: s.dayMonthYear(t, "from"),
      has: i
    };
  }
  isDateDisabled(t) {
    const s = this._utils, i = this._disabledDates;
    return new w(s, i).isDateDisabled(t);
  }
  isHighlightingNotPossible(t) {
    return !this.config.has.includeDisabled && this.isDateDisabled(t);
  }
  isDateHighlightedVia(t) {
    const s = this._highlighted, { has: i } = this.config;
    return {
      to: () => i.to && t < s.to,
      from: () => i.from && t > s.from,
      range: () => {
        if (!i.ranges) return !1;
        const { ranges: r } = s, a = I(this._utils);
        return r.some((n) => {
          const o = a.isDefined(n, "from"), l = a.isDefined(n, "to");
          return o && l && t <= n.to && t >= n.from;
        });
      },
      customPredictor: () => i.customPredictor && s.customPredictor(t),
      specificDate: () => i.specificDates ? s.dates.some((r) => this._utils.compareDates(t, r)) : !1,
      daysOfWeek: () => i.daysOfWeek ? s.days.indexOf(this._utils.getDay(t)) !== -1 : !1,
      daysOfMonth: () => i.daysOfMonth ? s.daysOfMonth.indexOf(this._utils.getDate(t)) !== -1 : !1
    };
  }
  isDateHighlighted(t) {
    if (this.isHighlightingNotPossible(t)) return !1;
    const s = this.isDateHighlightedVia(t);
    return s.to() || s.from() || s.range() || s.specificDate() || s.daysOfWeek() || s.daysOfMonth() || s.customPredictor();
  }
  isHighlightStart(t) {
    if (!this.config.has.ranges || !this.isDateHighlighted(t))
      return !1;
    for (let s = 0; s < this._highlighted.ranges.length; s += 1)
      if (this._highlighted.ranges[s].from.valueOf() === t.valueOf())
        return !0;
    return !1;
  }
  isHighlightEnd(t) {
    if (!this.config.has.ranges || !this.isDateHighlighted(t))
      return !1;
    for (let s = 0; s < this._highlighted.ranges.length; s += 1)
      if (this._highlighted.ranges[s].to.valueOf() === t.valueOf())
        return !0;
    return !1;
  }
}
const Ze = {
  name: "PickerDay",
  components: { PickerHeader: W, PickerCells: L },
  mixins: [x],
  props: {
    dayCellContent: {
      type: Function,
      default: (e) => e.date
    },
    firstDayOfWeek: {
      type: String
    },
    highlighted: {
      type: Object,
      default() {
        return {};
      }
    },
    mondayFirst: {
      type: Boolean,
      default: !1
    },
    showEdgeDates: {
      type: Boolean,
      default: !1
    },
    showFullMonthName: {
      type: Boolean,
      default: !1
    },
    twoLetterAbbr: {
      type: Boolean,
      default: !1
    }
  },
  emits: {
    pageChange: (e) => typeof e == "object",
    setFocus: (e) => e.every((t) => ["input", "prev", "up", "next", "tabbableCell"].includes(t)),
    setView: (e) => e === "month"
  },
  computed: {
    /**
     * Gets the name of the month the current page is on
     * @return {String}
     */
    currMonthName() {
      return this.showFullMonthName ? this.utils.getMonthName(this.pageMonth) : this.utils.getMonthNameAbbr(this.pageMonth);
    },
    /**
     * Gets the name of the year that current page is on
     * @return {String}
     */
    currYearName() {
      const e = H[this.language] || "";
      return `${this.pageYear}${e}`;
    },
    /**
     * @return {Object[]}
     */
    days() {
      const e = [], t = this.daysFromPrevMonth + this.daysInMonth + this.daysFromNextMonth, s = this.firstDayCellDate();
      for (let i = 0; i < t; i++)
        e.push(this.makeDay(s)), this.utils.setDate(s, this.utils.getDate(s) + 1);
      return e;
    },
    /**
     * Calculates how many days to show from the next month
     * @return {number}
     */
    daysFromNextMonth() {
      const e = this.daysFromPrevMonth + this.daysInMonth;
      return Math.ceil(e / 7) * 7 - e;
    },
    /**
     * Calculates how many days to show from the previous month
     * @return {number}
     */
    daysFromPrevMonth() {
      const e = this.utils.getDay(this.pageDate);
      return (7 - this.firstDayOfWeekNumber + e) % 7;
    },
    /**
     * Returns the number of days in this month
     * @return {String[]}
     */
    daysInMonth() {
      return this.utils.getDaysInMonth(this.pageDate);
    },
    /**
     * Returns an array of day names
     * @return {String[]}
     */
    daysOfWeek() {
      return this.utils.getDaysStartingOn(this.firstDayOfWeekNumber, this.twoLetterAbbr);
    },
    /**
     * Returns first-day-of-week as a number (Sunday is 0)
     * @return {Number}
     */
    firstDayOfWeekNumber() {
      return this.mondayFirst ? 1 : this.firstDayOfWeek ? this.utils.getDayFromAbbr(this.firstDayOfWeek) : 0;
    },
    /**
     * The first day of the next page's month.
     * @return {Date}
     */
    firstOfNextMonth() {
      const e = new Date(this.pageDate);
      return new Date(this.utils.setMonth(e, this.utils.getMonth(e) + 1));
    },
    /**
     * Is the next month disabled?
     * @return {Boolean}
     */
    isNextDisabled() {
      return this.disabledConfig.has.from ? this.disabledConfig.from.month <= this.pageMonth && this.disabledConfig.from.year <= this.pageYear : !1;
    },
    /**
     * Is the previous month disabled?
     * @return {Boolean}
     */
    isPreviousDisabled() {
      return this.disabledConfig.has.to ? this.disabledConfig.to.month >= this.pageMonth && this.disabledConfig.to.year >= this.pageYear : !1;
    },
    /**
     * Returns the current page's month as an integer.
     * @return {Number}
     */
    pageMonth() {
      return this.utils.getMonth(this.pageDate);
    },
    /**
     * Display the current page's month & year as the title.
     * @return {String}
     */
    pageTitleDay() {
      return Ne.indexOf(this.language.code) !== -1 ? `${this.currYearName} ${this.currMonthName}` : `${this.currMonthName} ${this.currYearName}`;
    }
  },
  methods: {
    /**
     * Set up a new date object to the first day of the current 'page'
     * @return {Date}
     */
    firstDayCellDate() {
      const e = new Date(this.pageDate);
      return new Date(this.utils.setDate(e, 1 - this.daysFromPrevMonth));
    },
    /**
     * Change the page month
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changeMonth({ incrementBy: e, focusRefs: t }) {
      const s = this.pageDate;
      this.utils.setMonth(s, this.utils.getMonth(s) + e), this.$emit("pageChange", { focusRefs: t, pageDate: s });
    },
    /**
     * Changes the page up or down
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changePage({ incrementBy: e, focusRefs: t }) {
      e === 1 && !this.isNextDisabled ? this.changeMonth({ incrementBy: e, focusRefs: t }) : e === -1 && !this.isPreviousDisabled && this.changeMonth({ incrementBy: e, focusRefs: t });
    },
    /**
     * Whether a day is selected
     * @param {Date} dObj to check if selected
     * @return {Boolean}
     */
    isSelectedDate(e) {
      return this.selectedDate && this.utils.compareDates(this.selectedDate, e);
    },
    /**
     * Whether a day is disabled
     * @param {Date} date to check if disabled
     * @return {Boolean}
     */
    isDisabledDate(e) {
      return this.disabledDates ? new w(this.utils, this.disabledDates).isDateDisabled(
        e
      ) : !1;
    },
    /**
     * Whether a day is highlighted (N.B. Disabled dates are not highlighted unless
     * `highlighted.includeDisabled` is true)
     * @param {Date} date to check if highlighted
     * @return {Boolean}
     */
    isHighlightedDate(e) {
      return this.highlighted ? new A(
        this.utils,
        this.disabledDates,
        this.highlighted
      ).isDateHighlighted(e) : !1;
    },
    /**
     * Whether a day is highlighted and it is the first date
     * in the highlighted range of dates
     * @param {Date} date
     * @return {Boolean}
     */
    isHighlightStart(e) {
      return this.highlighted ? new A(
        this.utils,
        this.disabledDates,
        this.highlighted
      ).isHighlightStart(e) : !1;
    },
    /**
     * Whether a day is highlighted and it is the first date
     * in the highlighted range of dates
     * @param {Date} date
     * @return {Boolean}
     */
    isHighlightEnd(e) {
      return this.highlighted ? new A(
        this.utils,
        this.disabledDates,
        this.highlighted
      ).isHighlightEnd(e) : !1;
    },
    /**
     * Defines the objects within the days array
     * @param  {Date} dObj
     * @return {Object}
     */
    makeDay(e) {
      const { utils: t } = this, s = t.getDay(e), i = e >= this.firstOfNextMonth, r = e < this.pageDate, a = s === 6, n = s === 0;
      return {
        date: this.showEdgeDates || !(r || i) ? t.getDate(e) : "",
        timestamp: e.getTime(),
        isSelected: this.isSelectedDate(e),
        isDisabled: this.isDisabledDate(e),
        isHighlighted: this.isHighlightedDate(e),
        isHighlightStart: this.isHighlightStart(e),
        isHighlightEnd: this.isHighlightEnd(e),
        isToday: t.compareDates(e, /* @__PURE__ */ new Date()),
        isWeekend: a || n,
        isSaturday: a,
        isSunday: n,
        isPreviousMonth: r,
        isNextMonth: i
      };
    }
  }
};
function _e(e, t, s, i, r, a) {
  const n = C("picker-header"), o = C("picker-cells");
  return B((h(), f("div", {
    class: c([e.calendarClass, "vdp-datepicker__calendar"]),
    style: U(e.calendarStyle),
    onMousedown: t[5] || (t[5] = d(() => {
    }, ["prevent"]))
  }, [
    g(e.$slots, "beforeCalendarHeader"),
    F(n, {
      ref: "pickerHeader",
      "bootstrap-styling": e.bootstrapStyling,
      "is-next-disabled": a.isNextDisabled,
      "is-previous-disabled": a.isPreviousDisabled,
      "is-rtl": e.isRtl,
      "is-up-disabled": e.isUpDisabled,
      "next-view-up": "month",
      "up-button-classes": "day__month_btn",
      onFocusInput: e.focusInput,
      onPageChange: t[0] || (t[0] = (l) => a.changePage(l)),
      onSetFocus: t[1] || (t[1] = (l) => e.$emit("setFocus", l)),
      onSetView: t[2] || (t[2] = (l) => e.$emit("setView", l))
    }, {
      default: b(() => [
        v(D(a.pageTitleDay), 1)
      ]),
      _: 1
    }, 8, ["bootstrap-styling", "is-next-disabled", "is-previous-disabled", "is-rtl", "is-up-disabled", "onFocusInput"]),
    y("div", {
      class: c({ "flex-rtl": e.isRtl })
    }, [
      (h(!0), f(j, null, q(a.daysOfWeek, (l) => (h(), f("span", {
        class: "cell day-header",
        key: l.timestamp
      }, D(l), 1))), 128)),
      F(o, {
        ref: "cells",
        "bootstrap-styling": e.bootstrapStyling,
        cells: a.days,
        "is-rtl": e.isRtl,
        "show-edge-dates": s.showEdgeDates,
        "tabbable-cell-id": e.tabbableCellId,
        view: "day",
        onArrow: t[3] || (t[3] = (l) => e.handleArrow(l)),
        onSelect: t[4] || (t[4] = (l) => e.select(l))
      }, {
        default: b(({ cell: l }) => [
          v(D(s.dayCellContent(l)), 1)
        ]),
        _: 1
      }, 8, ["bootstrap-styling", "cells", "is-rtl", "show-edge-dates", "tabbable-cell-id"])
    ], 2)
  ], 38)), [
    [Y, e.visible]
  ]);
}
const et = /* @__PURE__ */ M(Ze, [["render", _e]]), tt = {
  name: "PickerMonth",
  components: { PickerHeader: W, PickerCells: L },
  mixins: [x],
  emits: {
    pageChange: (e) => typeof e == "object",
    setFocus: (e) => e.every((t) => ["input", "prev", "up", "next", "tabbableCell"].includes(t)),
    setView: (e) => e === "year"
  },
  computed: {
    /**
     * Is the next year disabled?
     * @return {Boolean}
     */
    isNextDisabled() {
      return this.disabledConfig.has.from ? this.disabledConfig.from.year <= this.pageYear : !1;
    },
    /**
     * Is the previous year disabled?
     * @return {Boolean}
     */
    isPreviousDisabled() {
      return this.disabledConfig.has.to ? this.disabledConfig.to.year >= this.pageYear : !1;
    },
    months() {
      const e = this.pageDate, t = [], s = this.useUtc ? new Date(Date.UTC(e.getUTCFullYear(), 0, e.getUTCDate())) : new Date(e.getFullYear(), 0, e.getDate(), e.getHours(), e.getMinutes());
      for (let i = 0; i < 12; i++)
        t.push({
          month: this.utils.getMonthName(s),
          // , i, this.language.months),
          timestamp: s.getTime(),
          isDisabled: this.isDisabledMonth(s),
          isSelected: this.isSelectedMonth(s),
          isToday: this.isTodayMonth(s)
        }), this.utils.setMonth(s, this.utils.getMonth(s) + 1);
      return t;
    },
    /**
     * Display the current page's year as the title.
     * @return {String}
     */
    pageTitleMonth() {
      const e = H[this.language] || "";
      return `${this.pageYear}${e}`;
    }
  },
  methods: {
    /**
     * Changes the year up or down
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changeYear({ incrementBy: e, focusRefs: t }) {
      const s = this.pageDate;
      this.utils.setFullYear(s, this.utils.getFullYear(s) + e), this.$emit("pageChange", { focusRefs: t, pageDate: s });
    },
    /**
     * Changes the page up or down
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changePage({ incrementBy: e, focusRefs: t }) {
      e === 1 && !this.isNextDisabled ? this.changeYear({ incrementBy: e, focusRefs: t }) : e === -1 && !this.isPreviousDisabled && this.changeYear({ incrementBy: e, focusRefs: t });
    },
    /**
     * Whether the selected date is in this month
     * @param {Date} date
     * @return {Boolean}
     */
    isSelectedMonth(e) {
      return this.selectedDate && this.utils.getFullYear(this.selectedDate) === this.utils.getFullYear(e) && this.utils.getMonth(this.selectedDate) === this.utils.getMonth(e);
    },
    /**
     * Whether a month is disabled
     * @param {Date} date
     * @return {Boolean}
     */
    isDisabledMonth(e) {
      return this.disabledDates ? new w(this.utils, this.disabledDates).isMonthDisabled(
        e
      ) : !1;
    },
    /**
     * Whether the date has the same month and year as today's date
     * @param {Date} date
     * @return {Boolean}
     */
    isTodayMonth(e) {
      const { utils: t } = this, s = new Date(t.setDate(t.getNewDateObject(), 1));
      return t.compareDates(e, s);
    }
  }
};
function st(e, t, s, i, r, a) {
  const n = C("picker-header"), o = C("picker-cells");
  return B((h(), f("div", {
    class: c([e.calendarClass, "vdp-datepicker__calendar"]),
    style: U(e.calendarStyle),
    onMousedown: t[5] || (t[5] = d(() => {
    }, ["prevent"]))
  }, [
    g(e.$slots, "beforeCalendarHeader"),
    F(n, {
      ref: "pickerHeader",
      "bootstrap-styling": e.bootstrapStyling,
      "is-next-disabled": a.isNextDisabled,
      "is-previous-disabled": a.isPreviousDisabled,
      "is-rtl": e.isRtl,
      "is-up-disabled": e.isUpDisabled,
      "next-view-up": "year",
      "up-button-classes": "month__year_btn",
      onFocusInput: e.focusInput,
      onPageChange: t[0] || (t[0] = (l) => a.changePage(l)),
      onSetFocus: t[1] || (t[1] = (l) => e.$emit("setFocus", l)),
      onSetView: t[2] || (t[2] = (l) => e.$emit("setView", l))
    }, {
      default: b(() => [
        v(D(a.pageTitleMonth), 1)
      ]),
      _: 1
    }, 8, ["bootstrap-styling", "is-next-disabled", "is-previous-disabled", "is-rtl", "is-up-disabled", "onFocusInput"]),
    F(o, {
      ref: "cells",
      "bootstrap-styling": e.bootstrapStyling,
      cells: a.months,
      "is-rtl": e.isRtl,
      "tabbable-cell-id": e.tabbableCellId,
      view: "month",
      onArrow: t[3] || (t[3] = (l) => e.handleArrow(l)),
      onSelect: t[4] || (t[4] = (l) => e.select(l))
    }, {
      default: b(({ cell: l }) => [
        v(D(l.month), 1)
      ]),
      _: 1
    }, 8, ["bootstrap-styling", "cells", "is-rtl", "tabbable-cell-id"])
  ], 38)), [
    [Y, e.visible]
  ]);
}
const it = /* @__PURE__ */ M(tt, [["render", st]]), at = {
  name: "PickerYear",
  components: { PickerHeader: W, PickerCells: L },
  mixins: [x],
  props: {
    highlighted: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: {
    pageChange: (e) => typeof e == "object",
    setFocus: (e) => e.every((t) => ["input", "prev", "up", "next", "tabbableCell"].includes(t))
  },
  computed: {
    /**
     * Is the next decade disabled?
     * @return {Boolean}
     */
    isNextDisabled() {
      return this.disabledConfig.has.from ? this.disabledConfig.from.year <= this.pageDecadeEnd : !1;
    },
    /**
     * Is the previous decade disabled?
     * @return {Boolean}
     */
    isPreviousDisabled() {
      return this.disabledConfig.has.to ? this.disabledConfig.to.year >= this.pageDecadeStart : !1;
    },
    /**
     * The year at which the current yearRange starts
     * @return {Number}
     */
    pageDecadeStart() {
      return Math.floor(this.pageYear / 10) * 10;
    },
    /**
     * The year at which the current yearRange ends
     * @return {Number}
     */
    pageDecadeEnd() {
      return this.pageDecadeStart + 10 - 1;
    },
    years() {
      const e = this.pageDate, t = [], s = this.useUtc ? new Date(Date.UTC(Math.floor(e.getUTCFullYear() / 10) * 10, e.getUTCMonth(), e.getUTCDate())) : new Date(Math.floor(e.getFullYear() / 10) * 10, e.getMonth(), e.getDate(), e.getHours(), e.getMinutes());
      for (let i = 0; i < 10; i++)
        t.push({
          year: this.utils.getFullYear(s),
          timestamp: s.getTime(),
          isDisabled: this.isDisabledYear(s),
          isSelected: this.isSelectedYear(s),
          isToday: this.isTodayYear(s)
        }), this.utils.setFullYear(s, this.utils.getFullYear(s) + 1);
      return t;
    },
    /**
     * Display the current page's decade (or year range) as the title.
     * @return {String}
     */
    pageTitleYear() {
      const e = H[this.language] || "";
      return `${this.pageDecadeStart} - ${this.pageDecadeEnd}${e}`;
    }
  },
  methods: {
    /**
     * Changes the year up or down
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changeYear({ incrementBy: e, focusRefs: t }) {
      const s = this.pageDate;
      this.utils.setFullYear(s, this.utils.getFullYear(s) + e), this.$emit("pageChange", { focusRefs: t, pageDate: s });
    },
    /**
     * Changes the page up or down
     * @param {Number} incrementBy
     * @param {[String]} focusRefs
     */
    changePage({ incrementBy: e, focusRefs: t }) {
      e === 1 && !this.isNextDisabled ? this.changeYear({ incrementBy: e * 10, focusRefs: t }) : e === -1 && !this.isPreviousDisabled && this.changeYear({ incrementBy: e * 10, focusRefs: t });
    },
    /**
     * Whether the selected date is in this year
     * @param {Date} date
     * @return {Boolean}
     */
    isSelectedYear(e) {
      return this.selectedDate && this.utils.getFullYear(this.selectedDate) === this.utils.getFullYear(e);
    },
    /**
     * Whether a year is disabled
     * @param {Date} date
     * @return {Boolean}
     */
    isDisabledYear(e) {
      return this.disabledDates ? new w(this.utils, this.disabledDates).isYearDisabled(
        e
      ) : !1;
    },
    /**
     * Whether the date has the same year as today's date
     * @param {Date} date
     * @return {Boolean}
     */
    isTodayYear(e) {
      const { utils: t } = this, s = t.getFullYear(t.getNewDateObject());
      return t.getFullYear(e) === s;
    }
  }
};
function nt(e, t, s, i, r, a) {
  const n = C("picker-header"), o = C("picker-cells");
  return B((h(), f("div", {
    class: c([e.calendarClass, "vdp-datepicker__calendar"]),
    style: U(e.calendarStyle),
    onMousedown: t[4] || (t[4] = d(() => {
    }, ["prevent"]))
  }, [
    g(e.$slots, "beforeCalendarHeader"),
    F(n, {
      ref: "pickerHeader",
      "bootstrap-styling": e.bootstrapStyling,
      "is-next-disabled": a.isNextDisabled,
      "is-previous-disabled": a.isPreviousDisabled,
      "is-rtl": e.isRtl,
      "is-up-disabled": !0,
      onFocusInput: e.focusInput,
      onPageChange: t[0] || (t[0] = (l) => a.changePage(l)),
      onSetFocus: t[1] || (t[1] = (l) => e.$emit("setFocus", l))
    }, {
      default: b(() => [
        v(D(a.pageTitleYear), 1)
      ]),
      _: 1
    }, 8, ["bootstrap-styling", "is-next-disabled", "is-previous-disabled", "is-rtl", "onFocusInput"]),
    F(o, {
      ref: "cells",
      "bootstrap-styling": e.bootstrapStyling,
      cells: a.years,
      "is-rtl": e.isRtl,
      "tabbable-cell-id": e.tabbableCellId,
      view: "year",
      onArrow: t[2] || (t[2] = (l) => e.handleArrow(l)),
      onSelect: t[3] || (t[3] = (l) => e.select(l))
    }, {
      default: b(({ cell: l }) => [
        v(D(l.year), 1)
      ]),
      _: 1
    }, 8, ["bootstrap-styling", "cells", "is-rtl", "tabbable-cell-id"])
  ], 38)), [
    [Y, e.visible]
  ]);
}
const rt = /* @__PURE__ */ M(at, [["render", nt]]), lt = {
  name: "DatePicker",
  components: {
    DateInput: Le,
    PickerDay: et,
    PickerMonth: it,
    PickerYear: rt
  },
  mixins: [J, $e],
  props: {
    calendarClass: {
      type: [String, Object, Array],
      default: ""
    },
    dayCellContent: {
      type: Function
    },
    disabledDates: {
      type: Object
    },
    firstDayOfWeek: {
      type: String
    },
    fullMonthName: {
      type: Boolean
    },
    highlighted: {
      type: Object
    },
    initialView: {
      type: String,
      default: ""
    },
    language: {
      type: Object,
      default() {
        return S;
      }
    },
    maximumView: {
      type: String,
      default: "year"
    },
    minimumView: {
      type: String,
      default: "day"
    },
    mondayFirst: {
      type: Boolean
    },
    openDate: {
      validator: (e) => R.validateDateInput(e)
    },
    parseTypedDate: {
      type: Function
    },
    showEdgeDates: {
      type: Boolean,
      default: !1
    },
    twoLetterAbbr: {
      type: Boolean
    },
    modelValue: {
      validator: (e) => R.validateDateInput(e)
    },
    wrapperClass: {
      type: [String, Object, Array],
      default: ""
    }
  },
  emits: {
    changedMonth: (e) => typeof e == "object",
    changedYear: (e) => typeof e == "object",
    changedDecade: (e) => typeof e == "object",
    cleared: null,
    closed: null,
    "update:modelValue": (e) => e instanceof Date || e === null,
    opened: null,
    selected: (e) => e instanceof Date || e === null,
    selectedDisabled: (e) => typeof e == "object"
  },
  data() {
    const e = this.openDate ? new Date(this.openDate) : /* @__PURE__ */ new Date(), t = p(this.useUtc, this.language);
    return {
      /*
       * Positioning
       */
      calendarHeight: 0,
      isClickOutside: !1,
      /*
       * The latest valid `typedDate` (used for typeable datepicker)
       * {Date}
       */
      latestValidTypedDate: null,
      /*
       * Vue cannot observe changes to a Date Object so date must be stored as a timestamp
       * This represents the first day of the current viewing month
       * {Number}
       */
      pageTimestamp: t.setDate(e, 1),
      /*
       * Selected Date
       * {Date}
       */
      selectedDate: null,
      slideDuration: 250,
      resetTypedDate: /* @__PURE__ */ new Date(),
      utils: t,
      view: ""
    };
  },
  watch: {
    disabledDates: {
      handler() {
        const e = this.selectedDate || this.parseValue(this.modelValue);
        if (e) {
          if (this.isDateDisabled(e) && e) {
            this.setDate(null);
            return;
          }
          this.dateHasChanged(e) && this.setDate(e);
        }
      },
      deep: !0
    },
    initialView() {
      this.isOpen && this.setInitialView();
    },
    language(e) {
      this.utils = p(this.useUtc, e);
    },
    latestValidTypedDate(e) {
      this.setPageDate(e);
    },
    useUtc(e) {
      this.utils = p(e, this.language);
    },
    modelValue(e) {
      this.setValue(e);
    },
    openDate() {
      this.setPageDate();
    },
    view(e, t) {
      this.handleViewChange(e, t);
    }
  },
  computed: {
    computedInitialView() {
      return this.initialView ? this.initialView : this.minimumView;
    },
    computedOpenDate() {
      const e = this.parseValue(this.openDate), t = this.utils.getNewDateObject(e), s = this.selectedDate || t;
      return this.minimumView === "day" ? s : new Date(this.utils.setDate(s, 1));
    },
    calendarStyle() {
      return {
        position: this.isInline ? "static" : void 0
      };
    },
    datepickerId() {
      return `vdp-${Math.random().toString(36).slice(-10)}`;
    },
    isInline() {
      return !!this.inline;
    },
    isOpen() {
      return this.view !== "";
    },
    isRtl() {
      return z.indexOf(this.language) !== -1;
    },
    isUpDisabled() {
      return !this.allowedToShowView(this.nextView.up);
    },
    nextView() {
      const e = ["day", "month", "year"], t = (a) => a === this.view, s = e.findIndex(t), i = (a) => a <= 0 ? void 0 : e[a - 1];
      return {
        up: ((a) => {
          if (!(a < 0))
            return a === e.length - 1 ? "decade" : e[a + 1];
        })(s),
        down: i(s)
      };
    },
    pageDate() {
      return new Date(this.pageTimestamp);
    },
    picker() {
      const e = this.view || this.computedInitialView;
      return `Picker${this.ucFirst(e)}`;
    }
  },
  mounted() {
    this.init(), document.addEventListener("click", this.handleClickOutside);
  },
  beforeUnmount() {
    document.removeEventListener("click", this.handleClickOutside);
  },
  methods: {
    /**
     * Called in the event that the user navigates to date pages and
     * closes the picker without selecting a date.
     */
    resetDefaultPageDate() {
      if (this.selectedDate === null) {
        this.setPageDate();
        return;
      }
      this.setPageDate(this.selectedDate);
    },
    /**
     * Effectively a toggle to show/hide the calendar
     * @return {mixed}
     */
    open() {
      if (this.disabled || this.isInline)
        return !1;
      this.setInitialView(), this.reviewFocus(), this.$emit("opened");
    },
    /**
     * Parse a datepicker value from string/number to date
     * @param   {Date|String|Number|undefined} date
     * @returns {Date|null}
     */
    parseValue(e) {
      if (typeof e == "string" || typeof e == "number") {
        const t = new Date(e);
        return this.utils.isValidDate(t) ? t : null;
      }
      return this.utils.isValidDate(e) ? e : null;
    },
    /**
     * Select the date from a 'selectTypedDate' event
     * @param {Date=} date
     */
    selectTypedDate(e) {
      this.setDate(e.getTime()), this.reviewFocus(), this.isOpen && this.close();
    },
    /**
     * Sets the initial picker page view: day, month or year
     */
    setInitialView() {
      const e = this.computedInitialView;
      if (!this.allowedToShowView(e))
        throw new Error(
          `initialView '${this.initialView}' cannot be rendered based on minimum '${this.minimumView}' and maximum '${this.maximumView}'`
        );
      this.setView(e);
    },
    /**
     * Are we allowed to show a specific picker view?
     * @param {String} view
     * @return {Boolean}
     */
    allowedToShowView(e) {
      const t = ["day", "month", "year"], s = t.indexOf(this.minimumView), i = t.indexOf(this.maximumView), r = t.indexOf(e);
      return r >= s && r <= i;
    },
    /**
     * Set the selected date
     * @param {Number} timestamp
     */
    setDate(e) {
      const t = new Date(e);
      this.selectedDate = t, this.setPageDate(t), this.$emit("selected", t), this.$emit("update:modelValue", t);
    },
    /**
     * Clear the selected date
     */
    clearDate() {
      this.selectedDate = null, this.setPageDate(), this.$emit("selected", null), this.$emit("update:modelValue", null), this.focus.refs = ["input"], this.close(), this.$emit("cleared");
    },
    /**
     * Set the date
     * @param {Object} date
     */
    handleSelect(e) {
      if (this.allowedToShowView(this.nextView.down)) {
        this.showNextViewDown(e);
        return;
      }
      this.$refs.dateInput.typedDate = "", this.setDate(e.timestamp), this.focus.delay = e.isNextMonth ? this.slideDuration : 0, this.focus.refs = this.isInline ? ["tabbableCell"] : ["input"], this.close(), this.reviewFocus(), this.resetTypedDate = /* @__PURE__ */ new Date();
    },
    /**
     * @param {Object} date
     */
    selectDisabledDate(e) {
      this.$emit("selectedDisabled", e);
    },
    /**
     * Set the datepicker modelValue (and, if typeable, update `latestValidTypedDate`)
     * @param {Date|String|Number|null} date
     */
    setValue(e) {
      if (typeof e == "string" || typeof e == "number") {
        const t = this.utils.parseDate(e, this.format);
        e = isNaN(t.valueOf()) ? null : t;
      }
      this.selectedDate = e || null, this.setPageDate(e), this.typeable && (this.latestValidTypedDate = e || this.computedOpenDate);
    },
    /**
     * Set the picker view
     * @param {String} view
     */
    setView(e) {
      this.allowedToShowView(e) && (this.view = e);
    },
    /**
     * Sets the array of `refs` that might be focused following a view change
     * @param {String} newView The view being changed to
     * @param {String} oldView The previous view
     */
    setViewChangeFocusRefs(e, t) {
      if (t === "") {
        this.focus.refs = [];
        return;
      }
      const s = ["day", "month", "year"], i = (l) => l === e, r = (l) => l === t, a = s.findIndex(i), n = s.findIndex(r), o = a - n > 0;
      this.focus.refs = o ? ["up", "tabbableCell"] : ["tabbableCell", "up"];
    },
    /**
     * Sets the date that the calendar should open on
     */
    setPageDate(e) {
      e || (this.openDate ? e = new Date(this.openDate) : e = /* @__PURE__ */ new Date()), this.pageTimestamp = this.utils.setDate(new Date(e), 1);
    },
    /**
     * Updates the page (if necessary) after a 'typedDate' event and sets `tabbableCell` & `latestValidTypedDate`
     * @param {Date=} date
     */
    setTypedDate(e) {
      const t = new Date(this.pageDate);
      if (this.latestValidTypedDate = e || this.computedOpenDate, this.setPageDate(e), this.isPageChange(t)) {
        this.handlePageChange({
          focusRefs: [],
          pageDate: this.pageDate
        });
        return;
      }
      this.setTabbableCell();
    },
    /**
     * Focus the relevant element when the view changes
     * @param {String} newView
     * @param {String} oldView
     */
    handleViewChange(e, t) {
      const s = e === "", i = t === "" && this.isInline;
      s || i || (this.setViewChangeFocusRefs(e, t), this.reviewFocus());
    },
    /**
     * Close the calendar
     */
    close() {
      this.isInline || (this.view = "", this.isClickOutside ? this.isClickOutside = !1 : this.reviewFocus(), this.$emit("closed"));
    },
    /**
     * Closes the calendar when no element within it has focus
     */
    handleClickOutside(e) {
      if (!this.isOpen || this.inline)
        return;
      const t = e.target.closest(".vdp-datepicker");
      (t && t.id !== this.datepickerId || !t && !e.target.parentElement.closest(".vdp-datepicker__calendar")) && (this.isClickOutside = !0, this.close());
    },
    /**
     * Set the new pageDate, focus the relevant element and emit a `changed-<view>` event
     */
    handlePageChange({ focusRefs: e, pageDate: t }) {
      this.setPageDate(t), this.focus.refs = e, this.focus.delay = this.slideDuration || 250, this.reviewFocus(), this.$emit(`changed${this.ucFirst(this.nextView.up)}`, t);
    },
    /**
     * Returns true if element has the given className
     * @param   {HTMLElement} element
     * @param   {String}      className
     * @returns {Boolean}
     */
    hasClass(e, t) {
      return e && e.className.split(" ").includes(t);
    },
    /**
     * Used for typeable datepicker: returns true if a typed date causes the page to change
     * @param   {Date}    originalPageDate
     * @returns {Boolean}
     */
    isPageChange(e) {
      return this.isOpen ? e.valueOf() !== this.pageDate.valueOf() : !1;
    },
    /**
     * Initiate the component
     */
    init() {
      this.typeable && (this.latestValidTypedDate = this.selectedDate || this.computedOpenDate), this.modelValue && this.setValue(this.modelValue), this.isInline && this.setInitialView();
    },
    /**
     * Returns true if a date is disabled
     * @param {Date} date
     * @returns {Boolean}
     */
    isDateDisabled(e) {
      return this.disabledDates ? new w(this.utils, this.disabledDates).isDateDisabled(
        e
      ) : !1;
    },
    /**
     * Set the view to the next view down e.g. from `month` to `day`
     * @param {Object} cell The currently focused cell
     */
    showNextViewDown(e) {
      this.setPageDate(new Date(e.timestamp)), this.$emit(`changed${this.ucFirst(this.view)}`, e), this.setView(this.nextView.down);
    },
    /**
     * Capitalizes the first letter
     * @param {String} str The string to capitalize
     * @returns {String}
     */
    ucFirst(e) {
      return e[0].toUpperCase() + e.substring(1);
    }
  }
}, ot = ["id"];
function ut(e, t, s, i, r, a) {
  const n = C("date-input");
  return h(), f("div", {
    id: a.datepickerId,
    ref: "datepicker",
    class: c(["vdp-datepicker", [s.wrapperClass, a.isRtl ? "rtl" : ""]])
  }, [
    F(n, {
      id: e.id,
      ref: "dateInput",
      autofocus: e.autofocus,
      "bootstrap-styling": e.bootstrapStyling,
      "calendar-button": e.calendarButton,
      "calendar-button-icon": e.calendarButtonIcon,
      "calendar-button-icon-content": e.calendarButtonIconContent,
      "clear-button": e.clearButton,
      "clear-button-icon": e.clearButtonIcon,
      disabled: e.disabled,
      format: e.format,
      inline: e.inline,
      "input-class": e.inputClass,
      "is-open": a.isOpen,
      language: s.language,
      maxlength: e.maxlength,
      name: e.name,
      "open-date": s.openDate,
      "parse-typed-date": s.parseTypedDate,
      pattern: e.pattern,
      placeholder: e.placeholder,
      "ref-name": e.refName,
      required: e.required,
      "reset-typed-date": r.resetTypedDate,
      "selected-date": r.selectedDate,
      "show-calendar-on-focus": e.showCalendarOnFocus,
      tabindex: e.tabindex,
      typeable: e.typeable,
      "use-utc": e.useUtc,
      onClearDate: a.clearDate,
      onCloseCalendar: a.close,
      onOpen: a.open,
      onSelectTypedDate: a.selectTypedDate,
      onSetFocus: t[0] || (t[0] = (o) => e.setFocus(o)),
      onTab: e.tabThroughNavigation,
      onTypedDate: a.setTypedDate
    }, {
      calendarBtn: b(() => [
        g(e.$slots, "calendarBtn")
      ]),
      beforeDateInput: b(() => [
        g(e.$slots, "beforeDateInput")
      ]),
      clearBtn: b(() => [
        g(e.$slots, "clearBtn")
      ]),
      afterDateInput: b(() => [
        g(e.$slots, "afterDateInput")
      ]),
      _: 3
    }, 8, ["id", "autofocus", "bootstrap-styling", "calendar-button", "calendar-button-icon", "calendar-button-icon-content", "clear-button", "clear-button-icon", "disabled", "format", "inline", "input-class", "is-open", "language", "maxlength", "name", "open-date", "parse-typed-date", "pattern", "placeholder", "ref-name", "required", "reset-typed-date", "selected-date", "show-calendar-on-focus", "tabindex", "typeable", "use-utc", "onClearDate", "onCloseCalendar", "onOpen", "onSelectTypedDate", "onTab", "onTypedDate"]),
    (h(), Z(_(a.picker), {
      ref: "picker",
      "bootstrap-styling": e.bootstrapStyling,
      "calendar-class": s.calendarClass,
      calendarStyle: a.calendarStyle,
      "day-cell-content": s.dayCellContent,
      "disabled-dates": s.disabledDates,
      "first-day-of-week": s.firstDayOfWeek,
      highlighted: s.highlighted,
      "is-typeable": e.typeable,
      "is-up-disabled": a.isUpDisabled,
      language: s.language,
      "monday-first": s.mondayFirst,
      "page-date": a.pageDate,
      "selected-date": r.selectedDate,
      "show-edge-dates": s.showEdgeDates,
      "show-full-month-name": s.fullMonthName,
      "slide-duration": r.slideDuration,
      "tabbable-cell-id": e.tabbableCellId,
      "two-letter-abbr": s.twoLetterAbbr,
      "use-utc": e.useUtc,
      visible: a.isOpen,
      onPageChange: a.handlePageChange,
      onSelect: a.handleSelect,
      onSetFocus: t[1] || (t[1] = (o) => e.setFocus(o)),
      onSetView: a.setView,
      onSelectedDisabled: a.selectDisabledDate
    }, {
      beforeCalendarHeader: b(() => [
        g(e.$slots, "beforeCalendarHeader")
      ]),
      _: 3
    }, 40, ["bootstrap-styling", "calendar-class", "calendarStyle", "day-cell-content", "disabled-dates", "first-day-of-week", "highlighted", "is-typeable", "is-up-disabled", "language", "monday-first", "page-date", "selected-date", "show-edge-dates", "show-full-month-name", "slide-duration", "tabbable-cell-id", "two-letter-abbr", "use-utc", "visible", "onPageChange", "onSelect", "onSetView", "onSelectedDisabled"]))
  ], 10, ot);
}
const ct = /* @__PURE__ */ M(lt, [["render", ut]]);
export {
  ct as default
};
